commit a8e033f25853c7c7e6d12241b1be430ceefa36b9
Author: freddy77 <freddy77>
Date:   Sat Jul 31 11:20:34 2010 +0000

    allow mutex declaration inside structures

diff --git a/ChangeLog b/ChangeLog
index e4506ed..dd56276 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Sat Jul 31 13:20:26 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsthread.h: allow mutex declaration inside structures
+
 Sat Jul 31 10:05:48 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/ctlib/unittests/Makefile.am src/dblib/unittests/Makefile.am:
 	* src/tds/unittests/Makefile.am:
@@ -2796,4 +2799,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3103 2010/07/31 08:05:59 freddy77 Exp $
+$Id: ChangeLog,v 1.3104 2010/07/31 11:20:34 freddy77 Exp $
diff --git a/include/tdsthread.h b/include/tdsthread.h
index 92a17b8..9b24677 100644
--- a/include/tdsthread.h
+++ b/include/tdsthread.h
@@ -22,7 +22,7 @@
 #ifndef TDSTHREAD_H
 #define TDSTHREAD_H 1
 
-/* $Id: tdsthread.h,v 1.7 2010/02/12 10:16:17 freddy77 Exp $ */
+/* $Id: tdsthread.h,v 1.8 2010/07/31 11:20:35 freddy77 Exp $ */
 
 #undef TDS_HAVE_MUTEX
 
@@ -31,8 +31,11 @@
 #include <pthread.h>
 
 #define TDS_MUTEX_DEFINE(name) pthread_mutex_t name = PTHREAD_MUTEX_INITIALIZER
-#define TDS_MUTEX_LOCK(a) pthread_mutex_lock(a)
-#define TDS_MUTEX_UNLOCK(a) pthread_mutex_unlock(a)
+#define TDS_MUTEX_LOCK(mtx) pthread_mutex_lock(mtx)
+#define TDS_MUTEX_UNLOCK(mtx) pthread_mutex_unlock(mtx)
+#define TDS_MUTEX_DECLARE(name) pthread_mutex_t name
+#define TDS_MUTEX_INIT(mtx) do { *(mtx) = PTHREAD_MUTEX_INITIALIZER; } while(0)
+#define TDS_MUTEX_FREE(mtx) pthread_mutex_destroy(mtx)
 
 #define TDS_HAVE_MUTEX 1
 
@@ -50,17 +53,23 @@ void tds_win_mutex_lock(tds_win_mutex_t *mutex);
 /* void tds_win_mutex_unlock(tds_win_mutex_t *mutex); */
 
 #define TDS_MUTEX_DEFINE(name) tds_win_mutex_t name = { NULL, 0 }
-#define TDS_MUTEX_LOCK(a) \
-	do { if ((a)->done) EnterCriticalSection(&(a)->crit); else tds_win_mutex_lock(a); } while(0)
-#define TDS_MUTEX_UNLOCK(a) LeaveCriticalSection(&(a)->crit)
+#define TDS_MUTEX_LOCK(mtx) \
+	do { if ((mtx)->done) EnterCriticalSection(&(mtx)->crit); else tds_win_mutex_lock(mtx); } while(0)
+#define TDS_MUTEX_UNLOCK(mtx) LeaveCriticalSection(&(mtx)->crit)
+#define TDS_MUTEX_DECLARE(name) tds_win_mutex_t name
+#define TDS_MUTEX_INIT(mtx) do { (mtx)->lock = NULL; (mtx)->done = 0; } while(0)
+#define TDS_MUTEX_FREE(mtx) do { if ((mtx)->done) { DeleteCriticalSection(&(mtx)->crit); (mtx)->done = 0; } } while(0)
 
 #define TDS_HAVE_MUTEX 1
 
 #else
 
 #define TDS_MUTEX_DEFINE(name) int name
-#define TDS_MUTEX_LOCK(a)
-#define TDS_MUTEX_UNLOCK(a)
+#define TDS_MUTEX_LOCK(mtx)
+#define TDS_MUTEX_UNLOCK(mtx)
+#define TDS_MUTEX_DECLARE(name) int name
+#define TDS_MUTEX_INIT(mtx)
+#define TDS_MUTEX_FREE(mtx)
 
 #endif
 

